<?php

namespace STM\Stadium;

use \Exception;
use STM\StmFactory;

/**
 * Test class for Stadium.
 * Generated by PHPUnit on 2012-02-13 at 13:46:48.
 * @group team_stadium
 */
class StadiumTest extends \PHPUnit_Framework_TestCase {

    /** @var array(Stadium) */
    private $all_stadiums;

    protected function setUp() {
        $this->all_stadiums = StmFactory::find()->Stadium->findAll();
    }

    public function testfindById() {
        foreach ($this->all_stadiums as $stadium) {            
            parent::assertInstanceOf('\STM\Stadium\Stadium', StmFactory::find()->Stadium->findById($stadium->getId()));
        }
        // argument must be numeric
        parent::assertFalse(StmFactory::find()->Stadium->findById('nou camp'));
        parent::assertFalse(StmFactory::find()->Stadium->findById(null));
        parent::assertFalse(StmFactory::find()->Stadium->findById(new Exception()));
    }

    public function testFind_all() {
        parent::assertTrue(is_array($this->all_stadiums));
        foreach ($this->all_stadiums as $stadium) {            
            parent::assertInstanceOf('\STM\Stadium\Stadium', $stadium);
        }
    }

    public function testCreate() {
        parent::markTestSkipped('test in StadiumValidatorTest');
    }

    public function testDelete() {
        parent::markTestSkipped('only database fail');
    }

    public function testUpdate() {
       parent::markTestSkipped('test in StadiumValidatorTest');
    }

    public function testGet_id() {
        $this->assert_get_to_function('is_int', 'getId');
    }

    public function testGet_capacity() {
        $this->assert_get_to_function('is_int', 'getCapacity');
    }

    public function testTo_array() {
        $this->assert_get_to_function('is_array', 'toArray');
    }

    public function test__toString() {
        $this->assert_get_to_function('is_string', '__toString');
    }

    private function assert_get_to_function($function, $method_name) {
        foreach ($this->all_stadiums as $stadium) {
            parent::assertTrue($function($stadium->$method_name()));
        }
    }
}

?>